

#property indicator_chart_window
#property indicator_buffers 2

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted    // Weighted
};


extern int                AdxPeriod          = 14;             // Adx period
extern enPrices           PriceForBuiltInADX = pr_close;       // Built in Adx price type
extern int                STDRgresperiod     = 0;              // Std regression period
extern int                STDRgreslength     = 56;             // Standard regression length
extern double             STDRgreswidth      = 1.618;          // Standard regression width
extern bool               alertsOn           = true;           // Turn alerts on?
extern bool               alertsOnCurrent    = false;          // Alerts on still open bar?
extern bool               alertsMessage      = true;           // Alerts should show popup message?
extern bool               alertsSound        = false;          // Alerts should play a sound?
extern bool               alertsEmail        = false;          // Alerts should send email?
extern bool               alertsPushNotif    = false;          // Alerts should send notification?
extern int                UpArrowSize        = 4;              // Up Arrow size
extern int                DnArrowSize        = 4;              // Down Arrow size
extern int                UpArrowCode        = 159;            // Up Arrow code
extern int                DnArrowCode        = 159;            // Down arrow code
extern double             UpArrowGap         = 0.5;            // Up Arrow gap        
extern double             DnArrowGap         = 0.5;            // Dn Arrow gap
extern color              UpArrowColor       = clrWhite;       // Up Arrow Color
extern color              DnArrowColor       = clrWhite;       // Down Arrow Color
//---- buffers
double val1[];
double val2[];
double cross[];
double DIp[];
double DIm[];
double one,two,trend = 0,grad,b,a,starttime,hi,lo;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,val1); SetIndexStyle(0,DRAW_ARROW,0,UpArrowSize,UpArrowColor); SetIndexArrow(0,UpArrowCode);
   SetIndexBuffer(1,val2); SetIndexStyle(1,DRAW_ARROW,0,DnArrowSize,DnArrowColor); SetIndexArrow(1,DnArrowCode);
   SetIndexBuffer(2,DIp);   
   SetIndexBuffer(3,DIm);   
   SetIndexBuffer(4,cross);
return(0);
}
int deinit()
{ 
   ObjectsDeleteAll(0,OBJ_STDDEVCHANNEL); 
   ObjectsDeleteAll(0,OBJ_TRENDBYANGLE); 
   ObjectsDeleteAll(0,OBJ_TREND); 
   Comment(""); 
return(0);
}

//
//
//
//
//

int start()
{   
   int i,counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = fmin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
	
   for (i=limit; i>=0; i--)
	{
       starttime = iTime(Symbol(),STDRgresperiod,STDRgreslength);
          ObjectCreate("regression channel",OBJ_STDDEVCHANNEL,0,starttime,Bid,Time[0],Ask);
             ObjectSet("regression channel",OBJPROP_TIME1,starttime);
             ObjectSet("regression channel",OBJPROP_TIME2,Time[0]);
             ObjectSet("regression channel",OBJPROP_DEVIATION,STDRgreswidth);
             ObjectSet("regression channel",OBJPROP_RAY,true);
       one = ObjectGet("regression channel", OBJPROP_PRICE1);
       two = ObjectGet("regression channel", OBJPROP_PRICE2);
       string trendText="";
       if (one<two) { trend = 1;  b=two-one; }
       if (one>two) { trend =-1;  b=one-two; }
       if (trend == 1) { trendText = "up";   }
       if (trend ==-1) { trendText = "down"; }

            ObjectCreate("grad channel",OBJ_TRENDBYANGLE,0,0,0);
               ObjectSet("grad channel",OBJPROP_WIDTH,3);
               ObjectSet("grad channel",OBJPROP_TIME1,starttime);
               ObjectSet("grad channel",OBJPROP_TIME2,Time[0]);
               ObjectSet("grad channel",OBJPROP_PRICE1,one);
               ObjectSet("grad channel",OBJPROP_PRICE2,two); 
        grad = ObjectGet("grad channel", OBJPROP_ANGLE);
      
        hi = iHigh(NULL,PERIOD_D1,1);
        lo = iLow(NULL,PERIOD_D1,1);
        ObjectCreate("HDayBorder", OBJ_TREND,0,0,0, 0,0);
           ObjectSet("HDayBorder", OBJPROP_TIME1, StrToTime(TimeToStr(Time[STDRgreslength], TIME_DATE)+" 00:00"));
           ObjectSet("HDayBorder", OBJPROP_TIME2, Time[0]);
           ObjectSet("HDayBorder", OBJPROP_PRICE1, hi);
           ObjectSet("HDayBorder", OBJPROP_PRICE2, hi);
           ObjectSet("HDayBorder", OBJPROP_COLOR, clrBlue);
           ObjectSet("HDayBorder", OBJPROP_STYLE, STYLE_DASH);
        
        ObjectCreate("LDayBorder", OBJ_TREND, 0, 0,0, 0,0);
           ObjectSet("LDayBorder", OBJPROP_TIME1, StrToTime(TimeToStr(Time[STDRgreslength], TIME_DATE)+" 00:00"));
           ObjectSet("LDayBorder", OBJPROP_TIME2, Time[0]);
           ObjectSet("LDayBorder", OBJPROP_PRICE1, lo);
           ObjectSet("LDayBorder", OBJPROP_PRICE2, lo);
           ObjectSet("LDayBorder", OBJPROP_COLOR, clrRed);
           ObjectSet("LDayBorder", OBJPROP_STYLE, STYLE_DASH);
   
           Comment ("\nChannel Angle = ",grad,"\nTrend = ",trendText,"\nYesterdays High Price = ",hi,"\nYesterdays Low Price = ",lo);
           
           DIp[i] = iADX(NULL,0,AdxPeriod,(int)PriceForBuiltInADX,MODE_PLUSDI,i);
           DIm[i] = iADX(NULL,0,AdxPeriod,(int)PriceForBuiltInADX,MODE_MINUSDI,i);
           val1[i] = EMPTY_VALUE;
           val2[i] = EMPTY_VALUE;       
           cross[i] = (i<Bars-1) ? (DIp[i]>DIm[i+1]) ? 1 : (DIp[i]<DIm[i+1]) ? -1 : cross[i+1] : 0;  
           if (i<Bars-1 && cross[i] != cross[i+1])
           {
              if (cross[i] ==  1) val1[i] = Low[i] -iATR(NULL,0,15,i)*UpArrowGap;
              if (cross[i] == -1) val2[i] = High[i]+iATR(NULL,0,15,i)*DnArrowGap;
           }
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (cross[whichBar] != cross[whichBar+1])
      if (cross[whichBar] == 1)
            doAlert("crossing up");
      else  doAlert("crossing down");       
   }  
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Dex_Adx ",doWhat);
             if (alertsMessage)   Alert(message);
             if (alertsPushNotif) SendNotification(message);
             if (alertsEmail)     SendMail(StringConcatenate(Symbol()," Dex_Adx  "),message);
             if (alertsSound)     PlaySound("alert2.wav");
      }
}
      

